#ifndef DEFENS_VERIFY_FIXRACE_H
#define DEFENS_VERIFY_FIXRACE_H
#include <stdio.h>
#include <vector>
#include <set>
#include <sstream>

using namespace std;

enum Fix_Type {
	CRITICAL = 0,
	ORDER = 1,
	ATOMIC = 2,
	BARRIER = 3,
	EXISTING_CRITICAL = 4,
	UNKNOWN = 5
};

/**
 * There are at most two operations for each fix type. 
 * CRITICAL: lock, unlock
 * ORDER: wait, signal
 * ATOMIC: enter, exit
 * BARRIER: wait
 */
enum Operation_Type {
	START = 0,
	END = 1,
	MASTER = 2
};

struct Operation {
	Operation_Type type;
	string file_name;
	int line_no;
//	ADDRINT pos;
	string obj;
	string context;
};

struct Fix {
	Fix() : type(UNKNOWN) {}
	Fix_Type type;
	vector<Operation> ops;
	string fix_file_name;
};

struct FixOpInfo {
	string FixID;				// can be a var name, or a number.
	int FixType;
	int FixOpType;
};

set<void *> VisitedBBs;

#endif
